// #autoload
// #name = WeaponHitSounds
// #config = WeaponHitSoundsGUI
// #include = support/mission_callbacks.cs

function WeaponHitSoundsDefault()
{
	$WeaponHitSounds::blasterPlayerWav = "fx/weapons/cg_hard4.wav";
	$WeaponHitSounds::blasterVehicleWav = "fx/weapons/mine_switch.wav";
	$WeaponHitSounds::chaingunPlayerWav = "fx/weapons/cg_hard4.wav";
	$WeaponHitSounds::chaingunVehicleWav = "fx/weapons/mine_switch.wav";
	$WeaponHitSounds::discPlayerWav = "fx/weapons/cg_hard4.wav";
	$WeaponHitSounds::discVehicleWav = "fx/weapons/mine_switch.wav";
	$WeaponHitSounds::grenadelauncherPlayerWav = "fx/weapons/cg_hard4.wav";
	$WeaponHitSounds::grenadelauncherVehicleWav = "fx/weapons/mine_switch.wav";
	$WeaponHitSounds::missilelauncherPlayerWav = "fx/weapons/cg_hard4.wav";
	$WeaponHitSounds::missilelauncherVehicleWav = "fx/weapons/mine_switch.wav";
	$WeaponHitSounds::mortarPlayerWav = "fx/weapons/cg_hard4.wav";
	$WeaponHitSounds::mortarVehicleWav = "fx/weapons/mine_switch.wav";
	$WeaponHitSounds::plasmaPlayerWav = "fx/weapons/cg_hard4.wav";
	$WeaponHitSounds::plasmaVehicleWav = "fx/weapons/mine_switch.wav";
	$WeaponHitSounds::shocklancePlayerWav = "fx/weapons/cg_hard4.wav";
	$WeaponHitSounds::shocklanceVehicleWav = "fx/weapons/mine_switch.wav";
	$WeaponHitSounds::sniperriflePlayerWav = "fx/weapons/cg_hard4.wav";
	$WeaponHitSounds::sniperrifleVehicleWav = "fx/weapons/mine_switch.wav";
	if(isObject(WeaponHitSoundsList))
	{
		WeaponHitSoundsList.setSelected(-1);
		WeaponHitSoundsList.setText("Select a button, f00");
	}
}
if(!isFile("prefs/WeaponHitSoundsprefs.cs"))
{
	WeaponHitSoundsDefault();
	export("$WeaponHitSounds::*", "prefs/WeaponHitSoundsprefs.cs", false);
}
exec("prefs/WeaponHitSoundsprefs.cs");

package WeaponHitSounds
{
	function clientCmdSetWeaponsHudActive(%slot, %ret, %vis)
	{
		Parent::clientCmdSetWeaponsHudActive(%slot, %ret, %vis);
		switch$($WeaponNames[%slot])
		{
			case "blaster":
				$pref::Classic::playerHitSound = $WeaponHitSounds::blasterPlayerWav $= "_None.wav" ? 0:1;
				$pref::Classic::vehicleHitSound = $WeaponHitSounds::blasterVehicleWav $= "_None.wav" ? 0:1;
				$pref::Classic::playerHitWav = "~w"@$WeaponHitSounds::blasterPlayerWav;
				$pref::Classic::vehicleHitWav = "~w"@$WeaponHitSounds::blasterVehicleWav;
			case "plasma":
				$pref::Classic::playerHitSound = $WeaponHitSounds::plasmaPlayerWav $= "_None.wav" ? 0:1;
				$pref::Classic::vehicleHitSound = $WeaponHitSounds::plasmaVehicleWav $= "_None.wav" ? 0:1;
				$pref::Classic::playerHitWav = "~w"@$WeaponHitSounds::plasmaPlayerWav;
				$pref::Classic::vehicleHitWav = "~w"@$WeaponHitSounds::plasmaVehicleWav;
			case "chaingun":
				$pref::Classic::playerHitSound = $WeaponHitSounds::chaingunPlayerWav $= "_None.wav" ? 0:1;
				$pref::Classic::vehicleHitSound = $WeaponHitSounds::chaingunVehicleWav $= "_None.wav" ? 0:1;
				$pref::Classic::playerHitWav = "~w"@$WeaponHitSounds::chaingunPlayerWav;
				$pref::Classic::vehicleHitWav = "~w"@$WeaponHitSounds::chaingunVehicleWav;
			case "disc":
				$pref::Classic::playerHitSound = $WeaponHitSounds::discPlayerWav $= "_None.wav" ? 0:1;
				$pref::Classic::vehicleHitSound = $WeaponHitSounds::discVehicleWav $= "_None.wav" ? 0:1;
				$pref::Classic::playerHitWav = "~w"@$WeaponHitSounds::discPlayerWav;
				$pref::Classic::vehicleHitWav = "~w"@$WeaponHitSounds::discVehicleWav;
			case "grenadelauncher":
				$pref::Classic::playerHitSound = $WeaponHitSounds::grenadelauncherPlayerWav $= "_None.wav" ? 0:1;
				$pref::Classic::vehicleHitSound = $WeaponHitSounds::grenadelauncherVehicleWav $= "_None.wav" ? 0:1;
				$pref::Classic::playerHitWav = "~w"@$WeaponHitSounds::grenadelauncherPlayerWav;
				$pref::Classic::vehicleHitWav = "~w"@$WeaponHitSounds::grenadelauncherVehicleWav;
			case "sniperrifle":
				$pref::Classic::playerHitSound = $WeaponHitSounds::sniperriflePlayerWav $= "_None.wav" ? 0:1;
				$pref::Classic::vehicleHitSound = $WeaponHitSounds::sniperrifleVehicleWav $= "_None.wav" ? 0:1;
				$pref::Classic::playerHitWav = "~w"@$WeaponHitSounds::sniperriflePlayerWav;
				$pref::Classic::vehicleHitWav = "~w"@$WeaponHitSounds::sniperrifleVehicleWav;
			case "mortar":
				$pref::Classic::playerHitSound = $WeaponHitSounds::mortarPlayerWav $= "_None.wav" ? 0:1;
				$pref::Classic::vehicleHitSound = $WeaponHitSounds::mortarVehicleWav $= "_None.wav" ? 0:1;
				$pref::Classic::playerHitWav = "~w"@$WeaponHitSounds::mortarPlayerWav;
				$pref::Classic::vehicleHitWav = "~w"@$WeaponHitSounds::mortarVehicleWav;
			case "missilelauncher":
				$pref::Classic::playerHitSound = $WeaponHitSounds::missilelauncherPlayerWav $= "_None.wav" ? 0:1;
				$pref::Classic::vehicleHitSound = $WeaponHitSounds::missilelauncherVehicleWav $= "_None.wav" ? 0:1;
				$pref::Classic::playerHitWav = "~w"@$WeaponHitSounds::missilelauncherPlayerWav;
				$pref::Classic::vehicleHitWav = "~w"@$WeaponHitSounds::missilelauncherVehicleWav;
			case "shocklance":
				$pref::Classic::playerHitSound = $WeaponHitSounds::shocklancePlayerWav $= "_None.wav" ? 0:1;
				$pref::Classic::vehicleHitSound = $WeaponHitSounds::shocklanceVehicleWav $= "_None.wav" ? 0:1;
				$pref::Classic::playerHitWav = "~w"@$WeaponHitSounds::shocklancePlayerWav;
				$pref::Classic::vehicleHitWav = "~w"@$WeaponHitSounds::shocklanceVehicleWav;
		}
		if(MissionCallback.getServerMod() $= "classic") commandToServer('SetHitSounds', $pref::Classic::playerHitSound, $pref::Classic::playerHitWav, $pref::Classic::vehicleHitSound, $pref::Classic::vehicleHitWav);
	}
	function quit()
	{
		parent::quit();
		export("$WeaponHitSounds::*", "prefs/WeaponHitSoundsprefs.cs", false);
	}
};
activatePackage(WeaponHitSounds);

function SetWeaponHitSounds(%Wav)
{
	eval("$WeaponHitSoundsWav = " @ %Wav @ ";");
	$WeaponHitSoundsWavVar = %Wav;
	WeaponHitSoundsList.setSelected(0);
	for(%i = 0; WeaponHitSoundsList.getText() !$= ""; %i++)
	{
		WeaponHitSoundsList.setSelected(%i);
		if(WeaponHitSoundsList.getText() $= $WeaponHitSoundsWav) break;
	}
}

function TestHitSound()
{
	%handle = alxCreateSource(AudioGui, WeaponHitSoundsList.getText());
	alxStop($testHit);
	$testHit = alxPlay(%handle);
	alxPlay(%playsound);
}

function WeaponHitSoundsGUI::onWake(%this)
{
	WeaponHitSoundsList.clear();
	%count = 0;
	%path = "audio/*.wav";
	for(%file = findFirstFile(%path); %file !$= ""; %file = findNextFile(%path))
	{
		%file = strReplace(%file,"audio/","");
		WeaponHitSoundsList.add(%file,%count);
		%count++;
	}
	WeaponHitSoundsList.sort(1);
	WeaponHitSoundsList.setSelected(-1);
	WeaponHitSoundsList.setText("Select a button, f00");
}

function WeaponHitSoundsList::onSelect(%this,%id,%text)
{
	$WeaponHitSoundsWav = %text;
	eval($WeaponHitSoundsWavVar @ " =  $WeaponHitSoundsWav;");
}

new GuiControl(WeaponHitSoundsGUI) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "400 385";
	visible = "1";
	helpTag = "0";
	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "400 385";
		visible = "1";
		helpTag = "0";
		text = "Weapon Hit Sounds";
		maxLength = "255";
		noTitleBar = "0";
		new GuiTextCtrl() {
			profile = "ShellMediumTextProfile";
		    	horizSizing = "right";
		        vertSizing = "bottom";
		    	position = "30 37";
		        extent = "10 10";
		    	minExtent = "8 8";
		        visible = "1";
		    	helpTag = "0";
	        	text = "Blaster";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "165 30";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::blasterPlayerWav\");";
			helpTag = "0";
			text = "Player";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "270 30";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::blasterVehicleWav\");";
			helpTag = "0";
			text = "Vehicle";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
       		new GuiTextCtrl() {
	        	profile = "ShellMediumTextProfile";
			horizSizing = "right";
	        	vertSizing = "bottom";
		    	position = "30 67";
		    	extent = "10 10";
		    	minExtent = "8 8";
		    	visible = "1";
		    	helpTag = "0";
		    	text = "Plasma Rifle";
	    	};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "165 60";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::plasmaPlayerWav\");";
			helpTag = "0";
			text = "Player";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "270 60";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::plasmaVehicleWav\");";
			helpTag = "0";
			text = "Vehicle";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
    		new GuiTextCtrl() {
		    	profile = "ShellMediumTextProfile";
		    	horizSizing = "right";
		    	vertSizing = "bottom";
		    	position = "30 97";
		    	extent = "10 10";
		    	minExtent = "8 8";
		    	visible = "1";
		    	helpTag = "0";
		    	text = "Chaingun";
	    	};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "165 90";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::chaingunPlayerWav\");";
			helpTag = "0";
			text = "Player";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "270 90";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::chaingunVehicleWav\");";
			helpTag = "0";
			text = "Vehicle";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
    		new GuiTextCtrl() {
		    	profile = "ShellMediumTextProfile";
		    	horizSizing = "right";
			vertSizing = "bottom";
		    	position = "30 127";
		    	extent = "10 10";
		    	minExtent = "8 8";
		    	visible = "1";
		    	helpTag = "0";
		    	text = "Spinfusor";
	    	};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "165 120";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::discPlayerWav\");";
			helpTag = "0";
			text = "Player";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "270 120";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::discVehicleWav\");";
			helpTag = "0";
			text = "Vehicle";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
    		new GuiTextCtrl() {
			profile = "ShellMediumTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
		    	position = "30 157";
		    	extent = "10 10";
		    	minExtent = "8 8";
		    	visible = "1";
		    	helpTag = "0";
		    	text = "Grenade Launcher";
	    	};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "165 150";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::grenadelauncherPlayerWav\");";
			helpTag = "0";
			text = "Player";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "270 150";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::grenadelauncherVehicleWav\");";
			helpTag = "0";
			text = "Vehicle";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
    		new GuiTextCtrl() {
			profile = "ShellMediumTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 187";
			extent = "10 10";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "Laser Rifle";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "165 180";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::sniperriflePlayerWav\");";
			helpTag = "0";
			text = "Player";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "270 180";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::sniperrifleVehicleWav\");";
			helpTag = "0";
			text = "Vehicle";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
    		new GuiTextCtrl() {
		    	profile = "ShellMediumTextProfile";
		    	horizSizing = "right";
		    	vertSizing = "bottom";
		    	position = "30 217";
		    	extent = "10 10";
		    	minExtent = "8 8";
		    	visible = "1";
		    	helpTag = "0";
		    	text = "Fusion Mortar";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "165 210";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::mortarPlayerWav\");";
			helpTag = "0";
			text = "Player";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "270 210";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::mortarVehicleWav\");";
			helpTag = "0";
			text = "Vehicle";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
		new GuiTextCtrl() {
			profile = "ShellMediumTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 247";
			extent = "10 10";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "Missile Launcher";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "165 240";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::missilelauncherPlayerWav\");";
			helpTag = "0";
			text = "Player";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "270 240";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::missilelauncherVehicleWav\");";
			helpTag = "0";
			text = "Vehicle";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
		new GuiTextCtrl() {
			profile = "ShellMediumTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 277";
			extent = "10 10";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			text = "Shocklance";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "165 270";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::shocklancePlayerWav\");";
			helpTag = "0";
			text = "Player";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "270 270";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "SetWeaponHitSounds(\"$WeaponHitSounds::shocklanceVehicleWav\");";
			helpTag = "0";
			text = "Vehicle";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};

		new ShellPopupMenu(WeaponHitSoundsList) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 300";
			extent = "350 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "SoundTestButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "356 306";
			extent = "24 24";
			minExtent = "24 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "TestHitSound();";
			helpTag = "0";
			simpleStyle = "1";
		};
        	new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 330";
			extent = "110 36";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "WeaponHitSoundsDefault();";
			helpTag = "0";
			text = "Restore Defaults";
			longTextBuffer = "0";
			maxLength = "255";
			groupNum = "1";
		};
	};
};
